<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lib.inout.proot &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      <li>lib.inout.proot</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for lib.inout.proot</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module to open and save ROOT files.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span> <span class="nn">os.path</span> <span class="k">as</span> <span class="nn">op</span>
<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">List</span><span class="p">,</span> <span class="n">Union</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">uproot</span>

<span class="kn">from</span> <span class="nn">.serial</span> <span class="kn">import</span> <span class="n">try_makedirs</span>

<span class="kn">from</span> <span class="nn">..handle.handle_list</span> <span class="kn">import</span> <span class="n">_type_to_list</span><span class="p">,</span> <span class="n">remove_list_from_list</span>


<div class="viewcode-block" id="awkward_branches_into_dataframe"><a class="viewcode-back" href="../../../lib.inout.html#lib.inout.proot.awkward_branches_into_dataframe">[docs]</a><span class="k">def</span> <span class="nf">awkward_branches_into_dataframe</span><span class="p">(</span>
    <span class="n">file</span><span class="p">,</span> <span class="n">list_columns</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Union</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span> <span class="n">Optional</span><span class="p">[</span><span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">]]:</span>
    <span class="sd">&quot;&quot;&quot; Find and load awkward columns, that is, columns of type</span>
<span class="sd">    `&quot;std::vector&lt;double&gt;&quot;` that are vectors of more than 1 value.</span>

<span class="sd">    Args:</span>
<span class="sd">        file: uproot file</span>
<span class="sd">        list_columns: list of the columns that we want to load from</span>
<span class="sd">            the ``file``</span>

<span class="sd">    Returns:</span>
<span class="sd">        :</span>

<span class="sd">        * list_awkward_columns: list of awkward columns</span>
<span class="sd">        * awkward_dataframe: dataframe whose keys are given by \</span>
<span class="sd">            ``{column}_{number}`` where ``column`` is an awkward column \</span>
<span class="sd">            and ``number`` is the component of the vector ``column``</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">assert</span> <span class="n">uproot</span><span class="o">.</span><span class="n">__version__</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;4&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s2">&quot;Awkward branches only supported in&quot;</span>
                                          <span class="s2">&quot; uproot 4 onwards&quot;</span><span class="p">)</span>

    <span class="n">list_awkward_columns</span> <span class="o">=</span> <span class="p">[</span>
        <span class="n">column</span>
        <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">list_columns</span>
        <span class="k">if</span> <span class="n">file</span><span class="p">[</span><span class="n">column</span><span class="p">]</span><span class="o">.</span><span class="n">typename</span> <span class="o">==</span> <span class="s2">&quot;std::vector&lt;double&gt;&quot;</span>
    <span class="p">]</span>

    <span class="k">if</span> <span class="n">list_awkward_columns</span><span class="p">:</span>
        <span class="n">dataframe</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">()</span>
        <span class="n">awkward_array</span> <span class="o">=</span> <span class="n">file</span><span class="o">.</span><span class="n">arrays</span><span class="p">(</span><span class="n">list_awkward_columns</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">list_awkward_columns</span><span class="p">:</span>
            <span class="n">column_array</span> <span class="o">=</span> <span class="n">awkward_array</span><span class="p">[</span><span class="n">column</span><span class="p">]</span><span class="o">.</span><span class="n">to_numpy</span><span class="p">()</span>
            <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">column_array</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">1</span><span class="p">]):</span>
                <span class="n">dataframe</span><span class="p">[</span><span class="n">column</span> <span class="o">+</span> <span class="sa">f</span><span class="s2">&quot;_</span><span class="si">{i}</span><span class="s2">&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">column_array</span><span class="p">[:,</span> <span class="n">i</span><span class="p">]</span>

        <span class="k">return</span> <span class="n">list_awkward_columns</span><span class="p">,</span> <span class="n">dataframe</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">list_awkward_columns</span><span class="p">,</span> <span class="kc">None</span></div>


<div class="viewcode-block" id="open_samples"><a class="viewcode-back" href="../../../lib.inout.html#lib.inout.proot.open_samples">[docs]</a><span class="k">def</span> <span class="nf">open_samples</span><span class="p">(</span>
    <span class="n">file_paths</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]],</span>
    <span class="n">tree_name</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span>
    <span class="n">list_columns</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">verbose</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span>
    <span class="n">compl_mode</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
    <span class="n">reset_index</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span>
    <span class="n">dict_new_columns</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">dict</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Open a ROOT sample or several ROOT samples into one Pandas dataframe.</span>

<span class="sd">    Args:</span>
<span class="sd">        file_paths : path or list of paths of ROOT</span>
<span class="sd">            files</span>
<span class="sd">        tree_name : tree name in the ROOT files</span>
<span class="sd">        list_columns : List of the columns</span>
<span class="sd">            to load or not to load (if ``compl_mode`` is set at ``True``)</span>
<span class="sd">        verbose : whether to show the paths of the files</span>
<span class="sd">            that are loaded</span>
<span class="sd">        compl_mode : if set to ``True``, ``list_columns`` are</span>
<span class="sd">            the columns not to load.</span>
<span class="sd">        reset_index : whether to reset the indices of</span>
<span class="sd">            the resulting dataframe</span>
<span class="sd">        dict_new_columns : associates a column with a list of</span>
<span class="sd">            of values for each sample, in order to identify where the</span>
<span class="sd">            samples come from</span>

<span class="sd">    Raises:</span>
<span class="sd">        ValueError: uproot version is neither 3 nor 4</span>

<span class="sd">    Returns:</span>
<span class="sd">        pd.DataFrame: dataframe that contains all the ROOT samples</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">assert</span> <span class="n">uproot</span><span class="o">.</span><span class="n">__version__</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">in</span> <span class="p">[</span><span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;4&#39;</span><span class="p">],</span> <span class="p">(</span>
        <span class="sa">f</span><span class="s2">&quot;Uproot version </span><span class="si">{uproot.__version__}</span><span class="s2"> is not supported&quot;</span><span class="p">)</span>

    <span class="n">dataframe</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">()</span>
    <span class="n">file_paths</span> <span class="o">=</span> <span class="n">_type_to_list</span><span class="p">(</span><span class="n">file_paths</span><span class="p">,</span> <span class="nb">str</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">dict_new_columns</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">dict_new_columns</span> <span class="o">=</span> <span class="p">{}</span>

    <span class="k">for</span> <span class="n">column</span><span class="p">,</span> <span class="n">list_values</span> <span class="ow">in</span> <span class="n">dict_new_columns</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">list_values</span><span class="p">,</span> <span class="p">(</span><span class="nb">list</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">))</span> <span class="ow">and</span> <span class="nb">len</span><span class="p">(</span><span class="n">file_paths</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">dict_new_columns</span><span class="p">[</span><span class="n">column</span><span class="p">]</span> <span class="o">=</span> <span class="p">[</span><span class="n">list_values</span><span class="p">]</span>

    <span class="k">for</span> <span class="n">i_file</span><span class="p">,</span> <span class="n">file_path</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">file_paths</span><span class="p">):</span>
        <span class="n">root_file</span> <span class="o">=</span> <span class="n">uproot</span><span class="o">.</span><span class="n">open</span><span class="p">(</span><span class="n">file_path</span><span class="p">)[</span><span class="n">tree_name</span><span class="p">]</span>

        <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Load&quot;</span><span class="p">,</span> <span class="n">file_path</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">list_columns</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span> <span class="n">compl_mode</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">uproot</span><span class="o">.</span><span class="n">__version__</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;3&#39;</span><span class="p">:</span>
                <span class="n">list_all_columns</span> <span class="o">=</span> <span class="p">[</span>
                    <span class="n">column</span><span class="o">.</span><span class="n">decode</span><span class="p">()</span>
                    <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">root_file</span><span class="o">.</span><span class="n">keys</span><span class="p">()</span>
                <span class="p">]</span>
            <span class="k">elif</span> <span class="n">uproot</span><span class="o">.</span><span class="n">__version__</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;4&#39;</span><span class="p">:</span>
                <span class="n">list_all_columns</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">root_file</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span>

        <span class="k">if</span> <span class="n">list_columns</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">list_columns_to_load</span> <span class="o">=</span> <span class="n">list_all_columns</span>
        <span class="k">elif</span> <span class="n">compl_mode</span><span class="p">:</span>
            <span class="n">list_columns_to_load</span> <span class="o">=</span> <span class="n">list_all_columns</span>
            <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">list_columns</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">list_columns_to_load</span><span class="p">:</span>
                    <span class="n">list_columns_to_load</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">column</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">list_columns_to_load</span> <span class="o">=</span> <span class="n">list_columns</span>
        <span class="c1"># Find awkward columns</span>
        <span class="n">list_awkward_columns</span><span class="p">,</span> <span class="n">awkward_dataframe</span> <span class="o">=</span> <span class="p">(</span>
            <span class="n">awkward_branches_into_dataframe</span><span class="p">(</span><span class="n">root_file</span><span class="p">,</span> <span class="n">list_columns_to_load</span><span class="p">))</span>
        <span class="k">if</span> <span class="n">list_awkward_columns</span><span class="p">:</span>
            <span class="n">list_columns_to_load</span> <span class="o">=</span> <span class="n">remove_list_from_list</span><span class="p">(</span>
                <span class="n">list_columns_to_load</span><span class="p">,</span> <span class="n">list_awkward_columns</span>
            <span class="p">)</span>

        <span class="k">if</span> <span class="n">uproot</span><span class="o">.</span><span class="n">__version__</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;4&#39;</span><span class="p">:</span>
            <span class="n">sub_dataframe</span> <span class="o">=</span> <span class="n">root_file</span><span class="o">.</span><span class="n">arrays</span><span class="p">(</span>
                <span class="n">list_columns_to_load</span><span class="p">,</span> <span class="n">library</span><span class="o">=</span><span class="s2">&quot;pandas&quot;</span>
            <span class="p">)</span>
        <span class="k">elif</span> <span class="n">uproot</span><span class="o">.</span><span class="n">__version__</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;3&#39;</span><span class="p">:</span>
            <span class="n">sub_dataframe</span> <span class="o">=</span> <span class="n">root_file</span><span class="o">.</span><span class="n">arrays</span><span class="p">(</span>
                <span class="n">list_columns_to_load</span><span class="p">,</span> <span class="n">outputtype</span><span class="o">=</span><span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span>
            <span class="p">)</span>
        <span class="k">if</span> <span class="n">list_awkward_columns</span><span class="p">:</span>
            <span class="n">sub_dataframe</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">concat</span><span class="p">(</span>
                <span class="p">[</span><span class="n">sub_dataframe</span><span class="p">,</span> <span class="n">awkward_dataframe</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span>
            <span class="p">)</span>

        <span class="k">for</span> <span class="n">column</span><span class="p">,</span> <span class="n">list_values</span> <span class="ow">in</span> <span class="n">dict_new_columns</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">sub_dataframe</span><span class="p">[</span><span class="n">column</span><span class="p">]</span> <span class="o">=</span> <span class="n">list_values</span><span class="p">[</span><span class="n">i_file</span><span class="p">]</span>
        <span class="n">dataframe</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">concat</span><span class="p">([</span><span class="n">dataframe</span><span class="p">,</span> <span class="n">sub_dataframe</span><span class="p">],</span> <span class="n">ignore_index</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;# events:&quot;</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">sub_dataframe</span><span class="p">))</span>
    <span class="k">if</span> <span class="n">reset_index</span><span class="p">:</span>
        <span class="n">dataframe</span><span class="o">.</span><span class="n">reset_index</span><span class="p">(</span><span class="n">drop</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">dataframe</span></div>


<div class="viewcode-block" id="save_dataframe"><a class="viewcode-back" href="../../../lib.inout.html#lib.inout.proot.save_dataframe">[docs]</a><span class="k">def</span> <span class="nf">save_dataframe</span><span class="p">(</span>
        <span class="n">dataframe</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span> <span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">tree_name</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span>
        <span class="n">verbose</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">True</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Save a pandas dataframe into a ROOT file.</span>

<span class="sd">    Args:</span>
<span class="sd">        dataframe : sample</span>
<span class="sd">        path : where to save the sample</span>
<span class="sd">        tree_name : tree name where to save the dataframe in the ROOT</span>
<span class="sd">            file</span>
<span class="sd">        verbose : Whether to print information.</span>
<span class="sd">            Defaults to True.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">try_makedirs</span><span class="p">(</span><span class="n">op</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">path</span><span class="p">))</span>
    <span class="k">with</span> <span class="n">uproot</span><span class="o">.</span><span class="n">recreate</span><span class="p">(</span><span class="n">path</span><span class="p">)</span> <span class="k">as</span> <span class="n">out_file</span><span class="p">:</span>
        <span class="n">out_file</span><span class="p">[</span><span class="n">tree_name</span><span class="p">]</span> <span class="o">=</span> <span class="n">dataframe</span>
    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Root file saved in&quot;</span><span class="p">,</span> <span class="n">path</span><span class="p">)</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>